
#include <painlessMesh.h>

#define   MESH_PREFIX     "CLOD-"
#define   MESH_PASSWORD   "zIncsEcOndEnAtUrE666"
#define   MESH_PORT       5555

void receivedCallback( uint32_t from, String &msg );
void newConnectionCallback( bool adopt );

painlessMesh  *mesh = NULL;

void meshStart() {
  if (mesh == NULL) {
    mesh = new painlessMesh();
    //  | GENERAL
    //mesh->setDebugMsgTypes( ERROR | SYNC | MESH_STATUS | CONNECTION | COMMUNICATION | MSG_TYPES | REMOTE ); // all types on
    mesh->setDebugMsgTypes( ERROR | STARTUP );  // set before init() so that you can see startup messages
  
    mesh->init( MESH_PREFIX, MESH_PASSWORD, MESH_PORT );
    mesh->onReceive( &receivedCallback );
    mesh->onNewConnection( &newConnectionCallback );
  }
}

void meshStop() {
  if (MYDEBUG) Serial.printf("mesh: meshStop \n");
  // ?? mesh = NULL;
}

int meshConnectionCount() {
  if (mesh == NULL) return 0;
  return mesh->getNodeList().size();
}

void meshLoop() {
  if (mesh == NULL) return;
  mesh->update();
}

void meshSend(String msg) {
  if (mesh == NULL) return;
  mesh->sendBroadcast(msg);
}



